/*
 * JDecoradorFactoria.java
 *
 * Created on 31 de agosto de 2008, 10:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package mn.Impresion;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author eduardo
 */
public class JDecoradorFactoria {
    private final static List moListaDecoradores;
    /** Creates a new instance of JDecoradorFactoria */
    private JDecoradorFactoria() {
    }
    
    static{
        moListaDecoradores = new ArrayList();
        moListaDecoradores.add(
                new JDecoradorFactoriaElemento(
                "mn.Impresion.decoradores.JDecoradorMaya",
                "mn.Impresion.FFrameViewConDecoradores",
                "Maya"
                )
                );
    }
    
    public static List getListaDecoradores(final String psComponente){
        List loResult = new ArrayList();
        for(int i = 0 ; i < moListaDecoradores.size(); i++){
            JDecoradorFactoriaElemento loElem = (JDecoradorFactoriaElemento) moListaDecoradores.get(i);
            if(loElem.getAsociado().equals(psComponente)){
                loResult.add(loElem.clone());
            }
        }
        return loResult;
    }
    
}
