/*
* JTCAJAS.java
*
* Creado el 13/11/2007
*/

package mn.geoProcessing.area;

import ListDatos.*;
import ListDatos.estructuraBD.*;

public class JTUNIDADES extends JSTabla {
     /**
      * Variables para las posiciones de los campos
      */
      public static final int lPosiNOMBRE = 0;
      public static final int lPosiTIPO = 1;
      public static final int lPosiFACTORDECONVERSION = 2;
     /**
      * Variable nombre de tabla
      */
    public static final String msCTabla="UNIDADES";
     /**
      * Nmero de campos de la tabla
      */
    public static final int mclNumeroCampos=3;
     /**
      * Nombres de la tabla
      */
    public static final String[] masNombres=    new String[] {
        "NOMBRE",
        "TIPO",
        "FACTORDECONVERSION"
    };
    public static final String[] masCaption=    new String[] {
        "Nombre",
        "Tipo",
        "Factor de conversin a metro"
    };
    public static final int[] malTipos=    new int[] {
        JListDatos.mclTipoCadena,
        JListDatos.mclTipoCadena,
        JListDatos.mclTipoNumeroDoble
    };
    public static final int[] malTamanos=    new int[] {
        255,
        255,
        0
    };
    public static final int[] malCamposPrincipales=    new int[] {
        lPosiNOMBRE,
        lPosiTIPO
    };
     /**
      * Crea una instancia de la clase intermedia para la tabla FAMILIAS incluyendole el servidor de datos
      */
    public JTUNIDADES(IServerServidorDatos poServidorDatos) {
        super();
        moList = new JListDatos(poServidorDatos,msCTabla, masNombres, malTipos, malCamposPrincipales, masCaption, malTamanos);
        moList.addListener(this);
    }
     /**
      * Crea una instancia de la clase intermedia para la tabla FAMILIAS
      */
    public JTUNIDADES() {
      this(null);
    }
     public JFieldDef getNOMBRE(){
          return moList.getFields().get(lPosiNOMBRE);
     }
     public static String getNOMBRENombre(){
          return  masNombres[lPosiNOMBRE];
     }
     public JFieldDef getTIPO(){
          return moList.getFields().get(lPosiTIPO);
     }
     public static String getTIPONombre(){
          return  masNombres[lPosiTIPO];
     }
     public JFieldDef getFACTOR(){
          return moList.getFields().get(lPosiFACTORDECONVERSION);
     }
     public static String getFACTORNombre(){
          return  masNombres[lPosiFACTORDECONVERSION];
     }
    /**
    *recupera un objeto select segun la informacin actual
    *@return objeto select
    */
     public static JSelect getSelectStatico(){
         JSelect loSelect = new JSelect(msCTabla);
         for(int i = 0; i< masNombres.length; i++){
           loSelect.addCampo(msCTabla, masNombres[i]);
         }
         return loSelect;
     }
}
