/*
 * VistaSimpleGUI.java
 *
 * Created on 17 de julio de 2008, 8:17
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package mn.multivista.documents.gui;

import com.iver.andami.PluginServices;
import com.iver.cit.gvsig.fmap.ColorEvent;
import com.iver.cit.gvsig.fmap.ExtentEvent;
import com.iver.cit.gvsig.fmap.MapContext;
import com.iver.cit.gvsig.fmap.ProjectionEvent;
import com.iver.cit.gvsig.fmap.ViewPortListener;
import com.iver.cit.gvsig.fmap.layers.FLayers;
import com.iver.cit.gvsig.fmap.layers.FLyrVect;
import com.iver.cit.gvsig.project.documents.view.ProjectView;
import com.iver.cit.gvsig.project.documents.view.gui.View;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.util.ArrayList;
import java.util.List;


public class VistaSimpleGUI extends View {
    private static final long serialVersionUID = -2107874163035653981L;
    
    protected List moListenersZoomMover = new ArrayList();

	private ViewPortListener moviewPortListener;
    /** Creates a new instance of VistaSimpleGUI */
    public VistaSimpleGUI() {
        super();
    }
    public void addListenerZoomMover(IListenerZoomMover poZoomMover){
        moListenersZoomMover.add(poZoomMover);
    }
    public void removeListenerZoomMover(IListenerZoomMover poZoomMover){
        moListenersZoomMover.remove(poZoomMover);
    }
    public void llamarListenerZoomMover(){
        for(int i =0; i < moListenersZoomMover.size(); i++){
            IListenerZoomMover loZoomMover = (IListenerZoomMover)moListenersZoomMover.get(i);
            loZoomMover.zoomMover(this);
        }
    }
    public void setModel(ProjectView model) {
//        if(modelo!=null){
//        	modelo.
//        }
    	
    	
    	//borramos los listener previos
        if (m_MapControl.getViewPort() != null){
	        m_MapControl.getViewPort().removeViewPortListener(moviewPortListener);
        }
        
        //se clona FMap
        MapContext fmap=null;
        try {
			fmap = model.getMapContext().cloneToDraw();
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		//se clona la vista, ya q algunas herramientas usan
		//el MapContext de la vista directamente
    	ProjectView loView = new ProjectView();
    	loView.setComment(model.getComment());
    	loView.setCreationDate(model.getCreationDate());
    	loView.setExtLink(model.getExtLink());
    	loView.setMapContext(fmap);
    	loView.setMapOverViewContext(model.getMapOverViewContext().cloneToDraw());
    	loView.setName(model.getName());
    	loView.setOwner(model.getOwner());
    	loView.setProjection(model.getProjection());
    	loView.setSelectedField(model.getSelectedField());
    	loView.setTypeLink(loView.getTypeLink());
        loView.setProject(model.getProject(), model.getIndex());
        
    	this.modelo = loView;
		

        FLayers layers=fmap.getLayers();
		for (int i=0;i<layers.getLayersCount();i++){
			if (layers.getLayer(i).isEditing() && layers.getLayer(i) instanceof FLyrVect){
				this.showConsole();
			}
		}

		//Se configura el mapControl
        m_MapControl.setMapContext(fmap);
        m_TOC.setMapContext(fmap);
        m_MapControl.setBackground(new Color(255, 255, 255));
//        if (modelo.getMapOverViewContext()!=null){
//        	m_MapLoc.setModel(modelo.getMapOverViewContext());
//        }
//        model.addPropertyChangeListener(new PropertyChangeListener() {
//			public void propertyChange(PropertyChangeEvent evt) {
//				if (evt.getPropertyName().equals("name")){
//					PluginServices.getMDIManager().getWindowInfo(VistaSimpleGUI.this).setTitle("Vista: " + (String)evt.getNewValue());
//				}
//			}
//		});
        if (m_MapControl.getViewPort() != null){
        	moviewPortListener=new ViewPortListener() {
				public void extentChanged(ExtentEvent e) {
					if (PluginServices.getMainFrame() != null){
						PluginServices.getMainFrame().getStatusBar().setControlValue("scale",String.valueOf(m_MapControl.getMapContext().getScaleView()));
						PluginServices.getMainFrame().getStatusBar().setMessage("projection", getMapControl().getViewPort().getProjection().getAbrev());
					}
                  llamarListenerZoomMover();
				}

				public void backColorChanged(ColorEvent e) {
				}

				public void projectionChanged(ProjectionEvent e) {
					m_MapLoc.setProjection(e.getNewProjection());
				}
        	};
            if(getMapControl().getViewPort().getImageSize()==null){
        	  getMapControl().getViewPort().setImageSize(new Dimension(1,1));
            }
	        m_MapControl.getViewPort().addViewPortListener(moviewPortListener);
	      }
    	
    	
    }
    
    protected void initComponents() {
        super.initComponents();
        removeAll();
        this.add(getMapControl(), BorderLayout.CENTER);
    }
    
    
}
