/*
 * JPanelVistaSuperpuestaParametros.java
 *
 * Created on 10 de septiembre de 2008, 21:17
 */
package mn.vistaSuperpuesta;

import com.iver.andami.PluginServices;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.andami.ui.mdiManager.WindowInfo;
import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.tools.Behavior.Behavior;
import com.iver.cit.gvsig.fmap.tools.Behavior.MouseMovementBehavior;
import com.iver.cit.gvsig.project.documents.view.ProjectViewFactory;
import com.iver.cit.gvsig.project.documents.view.gui.View;
import java.awt.Rectangle;
import java.util.ArrayList;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;
import com.iver.cit.gvsig.project.Project;
import java.awt.event.MouseMotionListener;

/**
 *
 * @author  eduardo
 */
public class JPanelVistaSuperpuestaParametros extends javax.swing.JPanel implements IWindow {

    private static final long serialVersionUID = 6927236610787414775L;
    private Project moProyect;
    private WindowInfo viewInfo;
    private View moVista;
    private JVistaSuperpuestaParam moParam = new JVistaSuperpuestaParam();

    public JPanelVistaSuperpuestaParametros() {
        initComponents();
//        jSliderZOOM.setMajorTickSpacing(1);
//        jSliderZOOM.setMinorTickSpacing(1);
//        jSliderZOOM.setPaintLabels(true);
//        jSliderZOOM.setPaintTrack(true);
    }

    public void setDatos(View poVista) {
        moVista = poVista;
        moParam = new JVistaSuperpuestaParam();
        moProyect = moVista.getModel().getProject();

        MapControl mc = moVista.getMapControl();
        MouseMotionListener[] loListe = mc.getMouseMotionListeners();
        for (int i = 0; i < loListe.length; i++) {
            if (loListe[i].getClass().isAssignableFrom(JVistaSuperpuestaAccion.class)) {
                JVistaSuperpuestaAccion loAccion = (JVistaSuperpuestaAccion) loListe[i];
                moParam = loAccion.getParam();
                loAccion.terminado();
            }
        }

//        Behavior loEvento = moVista.getMapControl().getMapTool(VistaSuperpuestaExtension.mcsvistaSuperPuesta);
//        if(loEvento!=null && loEvento.getListener()!=null &&  
//        	JVistaSuperpuestaAccion.class.isAssignableFrom(loEvento.getListener().getClass())){
//            JVistaSuperpuestaAccion loAccion = (JVistaSuperpuestaAccion)loEvento.getListener();
//            moParam = loAccion.getParam();
//            loAccion.terminado();
//        }

        rellenarDespegablesDeVistas();
        txtAlto.setText(String.valueOf(moParam.getHeight()));
        txtAncho.setText(String.valueOf(moParam.getWidth()));
        jSliderZOOM.setValue(moParam.getZoom());
        jSliderTransparencia.setValue(moParam.getTransparencia());
        cmbTipo.setSelectedIndex(moParam.getTipoPintor());

        String lsNombre = "";
        //seleccionar lista de vistas
        if (moParam.getFuente() != null && moParam.getFuente().getNombre() != null) {
            lsNombre = moParam.getFuente().getNombre();
        } else {
            lsNombre = poVista.getModel().getName();
        }
        cmbListaVistas.getModel().setSelectedItem(lsNombre);
    }

    public void rellenarDespegablesDeVistas() {
        DefaultComboBoxModel model = null;

        ArrayList documents = moProyect.getDocumentsByType(ProjectViewFactory.registerName);

        model = new DefaultComboBoxModel(documents.toArray());

        cmbListaVistas.setModel(model);


        cmbListaVistas.updateUI();

        cmbTipo.removeAllItems();
        cmbTipo.addItem("Lupa");
        cmbTipo.addItem("Magnificar");

    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        cmbListaVistas = new javax.swing.JComboBox();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        txtAncho = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        txtAlto = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jSliderZOOM = new javax.swing.JSlider();
        jLabel5 = new javax.swing.JLabel();
        jSliderTransparencia = new javax.swing.JSlider();
        jLabel6 = new javax.swing.JLabel();
        cmbTipo = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        btnAceptar = new javax.swing.JButton();
        btnCancelar = new javax.swing.JButton();

        setLayout(new java.awt.GridBagLayout());

        jLabel1.setText("Vista");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(jLabel1, gridBagConstraints);

        cmbListaVistas.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(cmbListaVistas, gridBagConstraints);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Tamao de la lupa"));
        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel2.setText("Ancho");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        jPanel1.add(jLabel2, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        jPanel1.add(txtAncho, gridBagConstraints);

        jLabel3.setText("Alto");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        jPanel1.add(jLabel3, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        jPanel1.add(txtAlto, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(jPanel1, gridBagConstraints);

        jLabel4.setText("Escalado");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(jLabel4, gridBagConstraints);

        jSliderZOOM.setMajorTickSpacing(1);
        jSliderZOOM.setMaximum(5);
        jSliderZOOM.setMinimum(1);
        jSliderZOOM.setMinorTickSpacing(1);
        jSliderZOOM.setPaintLabels(true);
        jSliderZOOM.setSnapToTicks(true);
        jSliderZOOM.setValue(1);
        jSliderZOOM.setAutoscrolls(true);
        jSliderZOOM.setMinimumSize(new java.awt.Dimension(10, 40));
        jSliderZOOM.setPreferredSize(new java.awt.Dimension(10, 40));
        jSliderZOOM.setValueIsAdjusting(true);
        jSliderZOOM.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderZOOMStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(jSliderZOOM, gridBagConstraints);

        jLabel5.setText("Transparencia");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(jLabel5, gridBagConstraints);

        jSliderTransparencia.setMajorTickSpacing(25);
        jSliderTransparencia.setMinorTickSpacing(25);
        jSliderTransparencia.setPaintLabels(true);
        jSliderTransparencia.setValue(1);
        jSliderTransparencia.setAutoscrolls(true);
        jSliderTransparencia.setMinimumSize(new java.awt.Dimension(10, 40));
        jSliderTransparencia.setPreferredSize(new java.awt.Dimension(10, 40));
        jSliderTransparencia.setValueIsAdjusting(true);
        jSliderTransparencia.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                jSliderTransparenciaStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(jSliderTransparencia, gridBagConstraints);

        jLabel6.setText("Tipo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(jLabel6, gridBagConstraints);

        cmbTipo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(cmbTipo, gridBagConstraints);

        jPanel2.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        btnAceptar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/button_ok.png"))); // NOI18N
        btnAceptar.setMnemonic('g');
        btnAceptar.setText("Aceptar");
        btnAceptar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAceptarActionPerformed(evt);
            }
        });
        jPanel2.add(btnAceptar);

        btnCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/images/button_cancel.png"))); // NOI18N
        btnCancelar.setMnemonic('c');
        btnCancelar.setText("Cancelar");
        btnCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelarActionPerformed(evt);
            }
        });
        jPanel2.add(btnCancelar);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridwidth = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 2, 5, 0);
        add(jPanel2, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void jSliderTransparenciaStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderTransparenciaStateChanged
// TODO add your handling code here:
    }//GEN-LAST:event_jSliderTransparenciaStateChanged

    private void jSliderZOOMStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_jSliderZOOMStateChanged
//        lblNumero.setText(String.valueOf(jSliderZOOM.getValue()));
    }//GEN-LAST:event_jSliderZOOMStateChanged

    private void btnCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelarActionPerformed

        PluginServices.getMDIManager().closeWindow(this);

    }//GEN-LAST:event_btnCancelarActionPerformed

    private void btnAceptarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAceptarActionPerformed
        try {

            moParam.setHeight(Integer.valueOf(txtAlto.getText()).intValue());
            moParam.setWidth(Integer.valueOf(txtAncho.getText()).intValue());
            moParam.setZoom(jSliderZOOM.getValue());
            moParam.setFuente(new JVistaSuperpuestaFuenteVIEW(cmbListaVistas.getSelectedItem().toString(), moProyect));
            moParam.setTransparencia(jSliderTransparencia.getValue());
            moParam.setTipoPintor(cmbTipo.getSelectedIndex());


            MapControl mc = moVista.getMapControl();

            JVistaSuperpuestaAccion loNeutra =
                    new JVistaSuperpuestaAccion();
            loNeutra.setDatos(
                    mc,
                    moVista.getModel(),
                    moParam);
            mc.addMouseMotionListener(loNeutra);
//            mc.addMapTool(VistaSuperpuestaExtension.mcsvistaSuperPuesta,
//                    new MouseMovementBehavior(loNeutra)
//                    );
//            mc.setTool(VistaSuperpuestaExtension.mcsvistaSuperPuesta);         

            PluginServices.getMDIManager().closeWindow(this);
        } catch (Exception e) {
            e.printStackTrace();
            JOptionPane.showMessageDialog(this, e.toString());
        }
    }//GEN-LAST:event_btnAceptarActionPerformed

    public WindowInfo getWindowInfo() {

        if (viewInfo == null) {
            viewInfo=new WindowInfo(WindowInfo.MODALDIALOG);
            viewInfo.setTitle(PluginServices.getText(this,"vistaSuperpuesta"));
            viewInfo.setNormalBounds(0,0,350,300);
            viewInfo.setBounds(new Rectangle(0,0,350,300));

        }
        return viewInfo;		
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAceptar;
    private javax.swing.JButton btnCancelar;
    protected javax.swing.JComboBox cmbListaVistas;
    protected javax.swing.JComboBox cmbTipo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JSlider jSliderTransparencia;
    private javax.swing.JSlider jSliderZOOM;
    private javax.swing.JTextField txtAlto;
    private javax.swing.JTextField txtAncho;
    // End of variables declaration//GEN-END:variables
    
}
