package mn.Impresion;


import com.iver.cit.gvsig.project.documents.layout.FLayoutUtilities;
import com.iver.cit.gvsig.project.documents.layout.fframes.IFFrameLayoutDependence;
import java.awt.Component;
import java.awt.geom.Rectangle2D;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

import com.iver.andami.PluginServices;
import com.iver.andami.plugins.Extension;
import com.iver.andami.ui.mdiManager.IWindow;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.project.documents.layout.fframes.IFFrame;


public class LayoutDecoradoresFFrameExtension extends Extension{
    private static Logger logger = Logger.getLogger(LayoutDecoradoresFFrameExtension.class.getName());
    private Layout layout = null;
    /**
     * @see com.iver.andami.plugins.IExtension#initialize()
     */
    public void initialize() {
    } 
    
    /**
     * @see com.iver.andami.plugins.IExtension#execute(java.lang.String)
     */
    public void execute(String s) {
        layout = (Layout) PluginServices.getMDIManager().getActiveWindow();
        FFrameViewConDecoradores fframe = null;
        boolean isadd = false;
        fframe = new FFrameViewConDecoradores();
        ((IFFrameLayoutDependence)fframe).setLayout(layout);
        isadd = true;
        
        if (isadd) {
            Rectangle2D r = new Rectangle2D.Double(); //rectOrigin.x+m_PointAnt.x,rectOrigin.y+m_PointAnt.y,m_LastPoint.x-m_PointAnt.x,m_LastPoint.y-m_PointAnt.y);
            int tolerance=20;
//            r=getRectangle(tolerance);
            //se puede hacer q luego se ponga para redimensionar
            r.setRect(100,100,100,100);
            
            if (layout.isAdjustingToGrid()) {
                //cuadrar con la cuadrcula dibujada y despus en el mouseReleased guardar ese rectngulo de la misma forma.
                FLayoutUtilities.setRectGrid(r,
                        layout.getAtributes().getUnitInPixelsX(),
                        layout.getAtributes().getUnitInPixelsY(),
                        layout.getAT());
            }
            
            fframe.setBoundBox(FLayoutUtilities.toSheetRect(r, layout.getAT()));
            fframe.abrirPropiedadesConDecoradores(layout);
            layout.addFFrame(fframe, true,true);
        }
        
    }
    
    
    
    /**
     * @see com.iver.andami.plugins.IExtension#isEnabled()
     */
    public boolean isEnabled() {
        IWindow f = PluginServices.getMDIManager().getActiveWindow();
        
        if (f == null) {
            return false;
        }
        
        if (f instanceof Layout) {
            return true;
        }
        return false;
    }
    
    /**
     * @see com.iver.andami.plugins.IExtension#isVisible()
     */
    public boolean isVisible() {
        IWindow f = PluginServices.getMDIManager().getActiveWindow();
        
        if (f == null) {
            return false;
        }
        
        if (f instanceof Layout) {
            return true;
        }
        return false;
    }
    
}
