/*
 * JDecoradorMaya.java
 *
 * Created on 31 de agosto de 2008, 10:40
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package mn.Impresion.decoradores;

import com.iver.andami.messages.NotificationManager;
import com.iver.cit.gvsig.fmap.DriverException;
import com.iver.cit.gvsig.fmap.ViewPort;
import com.iver.cit.gvsig.gui.layout.Layout;
import com.iver.cit.gvsig.gui.layout.fframes.FFrameView;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import javax.swing.SwingUtilities;
import mn.Impresion.IDecorador;
import mn.Impresion.IDecoradorado;
import mn.Impresion.decoradores.gui.JFormDecoradorMaya;

/**
 *
 * @author eduardo
 */
public class JDecoradorMaya implements IDecorador {
    
    /** Creates a new instance of JDecoradorMaya */
    public JDecoradorMaya() {
    }
    
    public void draw(IDecoradorado poFrame, Graphics2D g, AffineTransform at, Rectangle2D rv, BufferedImage imgBase) throws DriverException {
        Rectangle2D.Double r = poFrame.getFFrame().getBoundingBox(at);
        if (poFrame.getFFrame().getRotation() != 0)
            g.rotate(Math.toRadians(poFrame.getFFrame().getRotation()), r.x + (r.width / 2), r.y
                    + (r.height / 2));
        
        if (poFrame.getFFrame().intersects(rv, r)) {
            if (((FFrameView)poFrame.getFFrame()).getMapContext() != null) {
//                if (rv != null) {
//                    // Dibujamos en pantalla
//                    Rectangle rclip = (Rectangle)g.getClipBounds().clone();
//                    g.clipRect((int) r.getMinX(), (int) r.getMinY(), (int) r
//                            .getWidth(), (int) r.getHeight());
//
////                    if (getQuality() == PRESENTACION) {
//                    if (rv.intersects(r)) {
//                        ViewPort viewPort = ((FFrameView)poFrame.getFFrame()).getMapContext().getViewPort();
//                        Color theBackColor = viewPort.getBackColor();
//                        if (origin != null
//                                && origin.equals(layout.getRectOrigin())
//                                && layout != null
//                                && layout.getAT().getScaleX() == scaleAnt
//                                && m_image != null && !refresh) {
//                            if (theBackColor != null) {
//                                g.setColor(theBackColor);
//                                g.fillRect((int) r.x, (int) r.y, viewPort
//                                        .getImageWidth(), viewPort
//                                        .getImageHeight());
//                            }
//                            g.translate(r.getX(), r.getY());
//                            g.drawImage(m_image, 0, 0, layout);
//                            g.translate(-r.getX(), -r.getY());
//                            scaleAnt = layout.getAT().getScaleX();
//                            origin = (Point) layout.getRectOrigin().clone();
//                        } else {
//
//
//                            System.err.println("r : " + r);
//                            if (r.getWidth() > layout.getWidth()
//                            || r.getHeight() > layout.getHeight()) {
//                                getMapContext().getViewPort().setOffset(
//                                        new Point2D.Double(r.getX(), r
//                                        .getY()));
//                                getMapContext().getViewPort().setImageSize(
//                                        new Dimension((int) r.getWidth(),
//                                        (int) r.getHeight()));
//                                MapContext fmap = getMapContext().cloneToDraw();
//                                ViewPort viewp = viewPort.cloneViewPort();
//                                viewp.setImageSize(new Dimension(
//                                        layout.getWidth(),
//                                        layout.getHeight()));
//                                Rectangle2D r1 = calculateExtent();
//                                double width = layout.getAtributes()
//                                .getSizeInUnits().getAncho();
//                                double scale = FLayoutUtilities
//                                        .getScaleView(viewp, width, r1
//                                        .getWidth()
//                                        / width);
//                                viewp.setExtent(r1);
//
//                                fmap.setViewPort(viewp);
//                                g.translate(-r.getX(), -r.getY());
//                                if (theBackColor != null) {
//                                    g.setColor(theBackColor);
//                                    g.fillRect((int) r.x, (int) r.y, viewp
//                                            .getImageWidth(), viewp
//                                            .getImageHeight());
//                                }
//                                fmap.draw(imgBase, g, scale);
//                                g.translate(r.getX(), r.getY());
//
//                            } else {
//                                getMapContext().getViewPort().setOffset(
//                                        new Point2D.Double(r.x, r.y));
//                                getMapContext().getViewPort().setImageSize(
//                                        new Dimension((int) r.width,
//                                        (int) r.height));
//                                m_image = new BufferedImage((int) r
//                                        .getWidth(), (int) r.getHeight(),
//                                        BufferedImage.TYPE_INT_ARGB);
//                                Graphics2D gimg = (Graphics2D) m_image
//                                        .getGraphics();
//                                gimg.translate(-((int) r.getX()), -((int) r
//                                        .getY()));
//                                getMapContext().draw(m_image, gimg, getScale());
//                                gimg.translate(((int) r.getX()), ((int) r
//                                        .getY()));
//                                if (theBackColor != null) {
//                                    g.setColor(theBackColor);
//                                    g.fillRect((int) r.x, (int) r.y, viewPort
//                                            .getImageWidth(), viewPort
//                                            .getImageHeight());
//                                }
//                                g.drawImage(m_image, (int) r.getX(),
//                                        (int) r.getY(), layout);
//                            }
//                            scaleAnt = layout.getAT().getScaleX();
//                            origin = (Point) layout.getRectOrigin().clone();
//                            refresh = false;
//                        }
//                    }
////                    } else {
////                        drawDraft(g);
////                    }
//                    if (rclip != null) {
//                        g.setClip(rclip.x, rclip.y, rclip.width,
//                                rclip.height);
//                    }
//                } else {
                // Dibujamos en impresora
                Rectangle rclip = g.getClipBounds();
                g.setColor(Color.black);
                g.clipRect((int) r.getMinX(), (int) r.getMinY(), (int) r.getWidth(),
                        (int) r.getHeight());
//                    ((FFrameView)poFrame.getFFrame()).getMapContext().
//                            getViewPort().setOffset(
//                                new Point2D.Double(r.x, r.y)
//                            );
//                    ((FFrameView)poFrame.getFFrame()).getMapContext().
//                            getViewPort().setImageSize(
//                                new Dimension(
//                                    (int) r.width,(int) r.height)
//                            );
                
                try {
//                        ((FFrameView)poFrame.getFFrame()).getMapContext().print(
//                                g,
//                                ((FFrameView)poFrame.getFFrame()).getScale(),
//                                ((FFrameView)poFrame.getFFrame()).getLayout().getAtributes().toPrintAttributes());
                    g.drawRect(
                            (int) r.getMinX(), (int) r.getMinY(),
                            (int)r.width-1,(int)r.height-1);
                } catch (Exception e) {
                    NotificationManager.addError(e.getMessage(), e);
                }
                
                g.setClip(rclip.x, rclip.y, rclip.width, rclip.height);
//                }
            }
        }
        if (poFrame.getFFrame().getRotation() != 0){
            g.rotate(Math.toRadians(-poFrame.getFFrame().getRotation()), r.x + (r.width / 2), r.y
                    + (r.height / 2));
        }
    }
    
    public void abrirPropiedades(final IDecoradorado poDecorado, final Layout poLayout) throws Exception{
        if(SwingUtilities.isEventDispatchThread()){
            JFormDecoradorMaya loMaya = new JFormDecoradorMaya(new Frame(), true);
            loMaya.setDatos(poDecorado, poLayout);
        }else{
            SwingUtilities.invokeAndWait(new Runnable() {
                public void run() {
                    JFormDecoradorMaya loMaya = new JFormDecoradorMaya(new Frame(), true);
                    loMaya.setDatos(poDecorado, poLayout);
                }
            }
            );
        }
    }
    
    public String getNombre() {
        return "Maya";
    }
    
}
