/*
 * JEnlaceGVGisSeleccion.java
 *
 * Created on 6 de septiembre de 2007, 10:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package mn.multivista.documents.gui;

import com.iver.cit.gvsig.fmap.MapControl;
import com.iver.cit.gvsig.fmap.tools.BehaviorException;
import com.iver.cit.gvsig.fmap.tools.Events.PointEvent;
import com.iver.cit.gvsig.fmap.tools.Events.RectangleEvent;
import com.iver.cit.gvsig.fmap.tools.Listeners.PointListener;
import com.iver.cit.gvsig.fmap.tools.Listeners.RectangleListener;
import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import javax.swing.ImageIcon;
import mn.multivista.documents.MultiVistaDocument;

public class JMultivistaAccionNeutra implements PointListener, RectangleListener {
    private final Image img = 
        new ImageIcon(MultiVistaDocument.class.getClassLoader().getResource("images/Select1.png")).getImage();
            
    private MapControl mapControl = null;
    
    private MultiVistaGUI moPadre;
    private VistaSimpleYComboGUI moVista;
    
    
    public JMultivistaAccionNeutra(final MapControl mapControl){
        this.mapControl = mapControl;
    }

    public void setDatos(final MultiVistaGUI poPadre,VistaSimpleYComboGUI poVista){
        moPadre = poPadre;
        moVista = poVista;
    }

    private void llamarListener(){
        moPadre.setVistaActivada(moVista);
    }
    
    public void rectangle(final RectangleEvent event) throws BehaviorException {
        llamarListener();
        mapControl.getMapContext().clearAllCachingImageDrawnLayers();
    }
    public void point(final PointEvent event) throws BehaviorException {
        llamarListener();
        mapControl.getMapContext().clearAllCachingImageDrawnLayers();
    }

    public void pointDoubleClick(PointEvent pointEvent) throws BehaviorException {
        llamarListener();
        mapControl.getMapContext().clearAllCachingImageDrawnLayers();
    }

    public boolean cancelDrawing() {
        return true;
    }
    public Cursor getCursor() {
        return Cursor.getDefaultCursor();//createCursor(img, new Point(16, 16));
    }

    public static Cursor createCursor(Image image, Point hotSpot) {
        if (null == image) {
            return Cursor.getDefaultCursor();
        }

        if (Toolkit.getDefaultToolkit().getBestCursorSize(32, 32).equals(
                new Dimension(0, 0))) {
            return Cursor.getDefaultCursor();
        }

        return Toolkit.getDefaultToolkit().createCustomCursor(image, hotSpot, "");
    }
}
